#include <sys/socket.h>

void log(int level, const char *fmt, ...);

struct zonedata;
struct dnspacket;

extern struct in_addr default_aaddr;

typedef struct zonedata *z_loadfn(const char *name, struct zonedata *data);
typedef int
z_queryfn(const struct zonedata *const zone, struct dnspacket *p,
	  const unsigned char *const query, unsigned qflg);

#define QUERY_A   0x01
#define QUERY_TXT 0x02

/* see details of DNS packet structure in rbldnsd.c */

int addrec_a(struct dnspacket *p, struct in_addr aip);
int addrec_txt(struct dnspacket *p, const char *txt, const char *subst);

int dn4octet(const unsigned char *q, struct in_addr *addrp);

/* list of zone types */
#define definezonetype(t) z_queryfn t##_query; z_loadfn t##_load
#define nameset_descr "set of names"
definezonetype(nameset);
#define nvset_descr "set of (name, value) pairs (inefficient)"
definezonetype(nvset);
#define ipset_descr "set of ip addresses with the same result"
definezonetype(ipset);
#define ipvset_descr "set of (ip, value) pairs"
definezonetype(ipvset);
#undef definezonetype

int ip4range(char *str, struct in_addr *ap);
int addrtxt(char *str, struct in_addr *ap, char **txtp);

void oom();
void *emalloc(unsigned size);
void *erealloc(void *ptr, unsigned size);
char *estrdup(const char *str);
char *esstrdup(const char *str);
struct mempool;
void *mp_ealloc(struct mempool *mp, unsigned size);
char *mp_estrdup(struct mempool *mp, const char *str);
